routes/web.php
<?php

use App\Http\Controllers\BookController;
use App\Http\Controllers\BorrowController;
use App\Http\Controllers\GenreController;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Input;
use Illuminate\Http\Request;

use App\Models\Book;
use App\Models\User;
use App\Models\Genre;
use App\Models\Borrow;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    $user_count = User::count();
    $book_count = Book::count();
    $genre_count = Genre::count();
    $accepted_borrow_count = Borrow::active_rentals()->count();
    $genres = Genre::all();

    return view('index', [
        'user_count' => $user_count,
        'book_count' => $book_count,
        'genre_count' => $genre_count,
        'accepted_borrow_count' => $accepted_borrow_count,
        'genres' => $genres
    ]);
});

Route::resource('books', BookController::class);
Route::resource('genres', GenreController::class);
Route::resource('borrows', BorrowController::class);

Route::get('/user/rentals', function() {
    $user = Auth::user();

    $b_pending = Borrow::where('reader_id', $user['id'])->
                         where('status', 'PENDING')->
                         get();

    $b_intime = Borrow::where('reader_id', $user['id'])->
                        where('status', 'ACCEPTED')->
                        where('deadline', '>=', now())->
                        get();

    $b_overdue = Borrow::where('reader_id', $user['id'])->
                         where('status', 'ACCEPTED')->
                         where('deadline', '<', now())->
                         get();

    $b_rejected = Borrow::where('reader_id', $user['id'])->
                          where('status', 'REJECTED')->
                          get();

    $b_returned = Borrow::where('reader_id', $user['id'])->
                          where('status', 'RETURNED')->
                          get();

    return view('borrow.user', [
        'b_pending' => $b_pending,
        'b_intime' => $b_intime,
        'b_overdue' => $b_overdue,
        'b_rejected' => $b_rejected,
        'b_returned' => $b_returned,
    ]);
})->middleware('auth');

Route::get('/profile', function() {
    $user = Auth::user();
    if (!$user) {
        return abort(403);
    }

    return view('profile', [
        'user' => $user
    ]);
});

Auth::routes();

Route::get('/logout', '\App\Http\Controllers\Auth\LoginController@logout');

app/Models/Book.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Book extends Model
{
    use HasFactory, SoftDeletes;

    protected $table = 'books';

    protected $fillable = [
        'title',
        'authors',
        'description',
        'released_at',
        'pages',
        'isbn',
        'in_stock',
    ];

    protected $casts = [
        'released_at' => 'date',
        'pages' => 'integer',
        'in_stock' => 'integer',
    ];

    public function genres() {
        return $this->belongsToMany(Genre::class);
    }

    public function borrows() {
        return $this->hasMany(Borrow::class);
    }

    public function available_count() {
        return $this->hasMany(Borrow::class)->where('status', '=', 'ACCEPTED')->count();
    }
}

app/Http/Controllers/BookController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\StoreBookRequest;
use App\Http\Requests\UpdateBookRequest;
use App\Models\Book;
use App\Models\Borrow;
use App\Models\Genre;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class BookController extends Controller
{
    static function get_validator() {
        return [
            'title' => 'required|max:255',
            'authors' => 'required|max:255',
            'released_at' => 'required|date|before:now',
            'pages' => 'required|integer|gt:0',
            'isbn' => 'required|regex:/^(?=(?:\D*\d){10}(?:(?:\D*\d){3})?$)[\d-]+$/i',
            'description' => 'present',
            'genres' => 'required|array',
            'in_stock' => 'required|integer|gte:0',
        ];
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $req)
    {
        $books = null;
        if ($req->input('q')) {
            $search = $req->input('q');
            $books = Book::where(function ($query) use($search) {
                $query->where('title', 'like', '%' . $search . '%')
                      ->orWhere('author', 'like', '%' . $search . '%');
            })->get();
        }
        else {
            $books = Book::all();
        }
        
        return view('book.list', [
            'books' => $books
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $this->authorize('create', Book::class);

        return view('book.create', [
            'genres' => Genre::all(),
            'init' => function($name) {
                return old($name);
            }
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \App\Http\Requests\StoreBookRequest  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreBookRequest $request)
    {
        //error_log($request);
        $this->authorize('create', Book::class);
        // https://laravel.com/docs/9.x/validation
        $val = $request->validate(BookController::get_validator());

        error_log( print_r($val, TRUE) );

        
        $book = Book::create($val);
        $book['cover_img'] = 'images/sample.png';
        $book->save();
        //error_log($book);

        return redirect('/');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function show(Book $book)
    {
        $user = Auth::user();
        return view('book.show', [
            'book' => $book,
            'available' => $book->available_count(),
            'user' => $user,
            'status' => $user ? Borrow::active_user_book($user, $book) : false
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function edit(Book $book)
    {
        $this->authorize('update', Book::class);

        return view('book.edit', [
            'genres' => Genre::all(),
            'id' => $book['id'],
            'init' => function($name) use ($book) {
                return $book[$name];
            }
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \App\Http\Requests\UpdateBookRequest  $request
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateBookRequest $request, Book $book)
    {
        $this->authorize('update', Book::class);
        $val = $request->validate(BookController::get_validator());

        $book->update($val);
        $book->save();

        return redirect()->route('book.show', ['book' => $book['id']]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function destroy(Book $book)
    {
        $this->authorize('delete', Book::class);
        $book->delete();
        return redirect('/');
    }
}

resources/views/book/create.blade.php
@extends('layouts.general')
@section('title', 'Create Book')
@section('content')

<div class="container-sm">
    <h1 class="mt-5">Add a New Book</h1>
    <form action="/books" method="POST">
        @csrf

        @include('book.form', ['genres' => $genres, 'init'=>$init])

        <input type="submit" class="btn btn-success" value="Add Book">
        <input type="reset" class="btn btn-danger" value="Reset">
    </form>
</div>

@endsection

resources/views/book/edit.blade.php
@extends('layouts.general')
@section('title', 'Edit Book')
@section('content')

<div class="container-sm">
    <h1 class="mt-5">Edit Book</h1>
    <form action="/books/{{$id}}" method="post">
        @csrf
        @method('patch')

        @include('book.form', ['genres' => $genres, 'init'=>$init])

        <input type="submit" class="btn btn-success" value="Save">
        <input type="reset" class="btn btn-danger" value="Cancel">
    </form>
</div>

@endsection

resources/views/book/form.blade.php
@include('components.formfield', [ 'title'=>'Title', 'name'=>'title', 'type'=>'text', 'init'=>$init])
@include('components.formfield', [ 'title'=>'Authors', 'name'=>'authors', 'type'=>'text', 'init'=>$init ])
@include('components.formfield', [ 'title'=>'Release Date', 'name'=>'released_at', 'type'=>'date', 'init'=>$init ])
@include('components.formfield', [ 'title'=>'ISBN', 'name'=>'isbn', 'type'=>'text', 'init'=>$init ])
@include('components.formfield', [ 'title'=>'Pages', 'name'=>'pages', 'type'=>'number', 'init'=>$init ])

@include('components.formarea', [ 'title'=>'description', 'name'=>'description', 'init'=>$init ])
@include('book.formgenres', [ 'genres'=>$genres, 'init'=>$init ])

@include('components.formfield', [ 'title'=>'In Stock', 'name'=>'in_stock', 'type'=>'number', 'init'=>$init ])

resources/views/book/formgenres.blade.php
<label for="genres" class="form-label">Genres</label>
<div class="mb-3">
    @foreach ($genres as $g)
    <div class="btn btn-outline-{{$g['style']}}">
        <input type="checkbox"
               name="genres[]"
               value={{$g['id']}}
               checked="{{ $init('genres') }}">
        <label>{{$g['name']}}</label>
    </div>
    @endforeach
</div>

resources/views/book/list.blade.php
@extends('layouts.general')

@section('title', 'Books')

@section('content')

@include('components.booklist')

@endsection

resources/views/book/show.blade.php
@extends('layouts.general')

@section('title', 'Books')

@section('content')

<div class="container-sm">
    <div class="row">
        <div class="col-xl-5 p-3">
            <img src={{ URL::asset( $book['cover_image'] ) }} class="card-img" alt={{ URL::asset( $book['title'] ) }}>
        </div>
        <div class="col-xl-5 p-3">
            <h1>{{ $book['title'] }}</h1>
            <hr>

            <h4>by: {{ $book['authors'] }}</h4>

            @include('components.genrelist', ['genres' => $book->genres])
            
            <h5 class="mt-4"> Details:</h5>
            <table class="table">
                <tr>
                    <td>Release Date:</td>
                    <td>{{ $book['released_at']->format('d/m/Y') }}</td>
                </tr>
                <tr>
                    <td>Pages:</td>
                    <td>{{ $book['pages'] }}</td>
                </tr>
                <tr>
                    <td>Language:</td>
                    <td>{{ $book['language_code'] }}</td>
                </tr>
                <tr>
                    <td>ISBN:</td>
                    <td>{{ $book['isbn'] }}</td>
                </tr>
            </table>

            <div class="badge bg-{{ $available == 0 ? 'danger' : 'success' }}">
                Available: {{ $available }} / {{ $book['in_stock'] }}
            </div>

            {{-- User Menu --}}
            @if ($user && !$user['is_librarian'])
                @if ($status)
                <p>You have an active rental for this book.</p>
                <a onclick="alert('You already have a rental for this book!')" class="btn btn-primary">Rent</a>
                @else
                <p>You have no current rental for this book.</p>
                <a href="/borrows/create?book={{ $book['id'] }}" class="btn btn-primary">Rent</a>
                @endif
            @endif

            {{-- Librarian Menu --}}
            @if ($user && $user['is_librarian'])
                <a href="/books/{{ $book['id'] }}/edit" class="btn btn-primary">Edit</a>
                <form action="{{ route('books.destroy', ['book'=>$book['id']]) }}" method="POST">
                    @csrf
                    @method('delete') {{-- ?? --}}
                    <input type="submit" class="btn btn-danger" value="Delete">
                </form>
            @endif

            <p class="text-justify mt-5">
                {{ $book['description'] }}
            </p>
        </div>
    </div>
</div>

@endsection